/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.apache.nifi.repository.encryption.metadata.serialization;

import org.apache.nifi.repository.encryption.metadata.RecordMetadata;

/**
 * Standard Record Metadata implementing Record Metadata methods
 */
class StandardRecordMetadata extends SerializableRecordMetadata implements RecordMetadata {
    private static final long serialVersionUID = 1;

    @Override
    public String getKeyId() {
        return keyId;
    }

    @Override
    public byte[] getInitializationVector() {
        return ivBytes;
    }

    @Override
    public int getLength() {
        return cipherByteLength;
    }

    @Override
    public String getAlgorithm() {
        return algorithm;
    }

    @Override
    public String getVersion() {
        return version;
    }
}
